# The Qubes OS Project, https://www.qubes-os.org
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, see <https://www.gnu.org/licenses/>.

Name:		qubes-rpm-oxide
Version:	0.2.5
Release:	1%{dist}
Summary:	RPM Canonicalization

Group:		Qubes
Vendor:		Invisible Things Lab
License:	MIT OR Apache-2.0
URL:		https://www.qubes-os.org

BuildRequires:  rust >= 1.21
BuildRequires:  cargo
BuildRequires:  rpm-devel >= 4.14.2.1-4
BuildRequires:  rust-debugger-common

Requires:       rpm >= 4.14.2.1-4

Source0: %{name}-%{version}.tar.gz

%description
RPM canonicalization and verification tools

%prep
%setup -q
%build
RUSTFLAGS='-Cdebuginfo=2 -Clink-arg=-z,relro,-z,now' RUSTC_BOOTSTRAP=1 cargo build --all-features --release

%install
install -D -m 0755 -- target/release/rpmcanon "$RPM_BUILD_ROOT"/%{_bindir}/rpmcanon

%check
RUSTC_BOOTSTRAP=1 cargo test --all-features --release --
%clean
rm -rf "$RPM_BUILD_ROOT" '%{name}-%{version}'

%files
%attr(755,root,root) %{_bindir}/rpmcanon

%changelog
* Tue Jul 19 2022 Qubes OS Team <qubes-devel@googlegroups.com>
- For complete changelog see: https://github.com/QubesOS/qubes-rpm-oxide

* Tue Jul 19 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - c206db8
- version 0.2.5

* Sat Jul 09 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - bc95e02
- Revert "Check that i18nstrings are valid and consistent"

* Sun Jun 26 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 588f9eb
- Better error messages for corrupt packages

* Mon May 09 2022 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - 73b2fbf
- .qubesbuilder: replace 'spec' by 'build'

* Mon Apr 25 2022 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - 7d96f02
- Add Qubes Builder v2 integration

* Mon Mar 21 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - e42b04f
- Check that i18nstrings are valid and consistent

* Wed Mar 16 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - e9bcd67
- Remove a huge amount of unnecessary locking

* Sun Feb 27 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 4026fbc
- Specify the minimum supported Rust and RPM versions

* Wed Feb 23 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 13d7370
- Fix build on old Rust versions

* Wed Feb 23 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - c5993a9
- Serialize all calls to RPM keyring and transaction functions

* Fri Feb 18 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - d19eadd
- version 0.2.4

* Thu Feb 17 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 9802ba1
- Forbid duplicate tags in packages

* Sun Dec 12 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 6c0ae46
- version 0.2.3

* Tue Nov 30 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - c1242a8
- Avoid using gobs of memory in unit-tests

* Tue Nov 30 2021 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - 32735d1
- debian: make the build reproducible

* Tue Nov 30 2021 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - 390d64a
- debian: simplify dh_auto_install

* Tue Nov 30 2021 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - dc9a7a8
- spec: reformat and use %{_bindir} in %file

* Mon Nov 29 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 1a5ffb7
- Debian packaging support

* Sun Nov 28 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 6aab763
- Add progress reporting support

* Sun Nov 28 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - b20cfe7
- Enable build for domU as well as dom0

* Sun Nov 28 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 4b4de7e
- Remove useless cast

* Sun Nov 28 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 5812d4b
- Allow specifying a custom path to the rpmdb

* Sun Nov 28 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - b924f97
- Fix bug in signature header validation

* Tue Nov 23 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - d1b443e
- Avoid using empty enums where not needed

* Tue Nov 23 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - c9e9da7
- rustfmt

* Fri Jun 04 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 35e2163
- Move rpmcanon’s canonicalization code to the library

* Thu Jun 03 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - a7c8164
- Add tests for old-format packet parsing

* Thu Jun 03 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 388c048
- Add way more packet serialization and parsing tests

* Thu Jun 03 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - af1b2db
- Fix `alloc` feature

* Thu Jun 03 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - f721b61
- Add a bunch more tests

* Thu Jun 03 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 627d98c
- Add documentation for the public key algorithm constants

* Thu Jun 03 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 4a3db53
- Fix building openpgp-parser #![no_std]

* Thu Jun 03 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 950cbb7
- Avoid hard-coding binary signatures

* Sun May 30 2021 Colin Walters <walters@verbum.org> - 1972e23
- rpm-parser: [clippy] Remove unnecessary clone()

* Thu May 27 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - dbe191e
- Run rustfmt

* Thu May 27 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - dcde3f8
- Reject expired signatures, not unexpired ones!

* Wed May 26 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - f53b8ef
- MD5 must never be used for signatures

* Wed May 26 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 3d2a825
- Make docs for check_hash_algorithm match reality

* Wed May 26 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 8d5fcc5
- Return correct error on unsupported signature versions

* Wed May 26 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 25b89eb
- Add tests for the MPI reader

* Thu May 13 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 466b148
- Always produce new-format packets

* Mon Apr 26 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 859ee52
- version 0.2.2

* Mon Apr 26 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 0da8ae2
- Input packet format must not affect serialized output

* Thu Apr 22 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - e7c67e6
- version 0.2.1

* Thu Apr 22 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 9d17d92
- ci: add config

* Thu Apr 22 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 677b8ef
- Revert "Check Cargo.lock into git"

* Thu Apr 22 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 5c182f1
- Check Cargo.lock into git

* Thu Apr 22 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - f14384b
- Move data files to subdirectory

* Thu Apr 22 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - b6e983e
- .gitignore generated packages

* Thu Apr 22 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 2fdca35
- Bump version to 0.2.0

